# coding: utf-8

"""
    DBaaS

    Manage your databases using our API

    The version of the OpenAPI document: 1.0.0
    Contact: info@liara.ir
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictBool
from pydantic import Field

class DBDetailsDatabaseMetaData(BaseModel):
    """
    DBDetailsDatabaseMetaData
    """
    standalone_replica_set: Optional[StrictBool] = Field(default=None, description="Indicates if the database uses a standalone replica set", alias="standaloneReplicaSet")
    private_network: Optional[StrictBool] = Field(default=None, description="Indicates if the database is on a private network", alias="privateNetwork")
    __properties: ClassVar[List[str]] = ["standaloneReplicaSet", "privateNetwork"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DBDetailsDatabaseMetaData:
        """Create an instance of DBDetailsDatabaseMetaData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.model_dump(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DBDetailsDatabaseMetaData:
        """Create an instance of DBDetailsDatabaseMetaData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DBDetailsDatabaseMetaData.model_validate(obj)

        _obj = DBDetailsDatabaseMetaData.model_validate({
            "standaloneReplicaSet": obj.get("standaloneReplicaSet"),
            "privateNetwork": obj.get("privateNetwork")
        })
        return _obj


