# coding: utf-8

"""
    DNS

    Manage dns zones and records

    The version of the OpenAPI document: 1.0.0
    Contact: info@liara.ir
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field

class Zone(BaseModel):
    """
    Zone
    """
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = Field(default=None, description="The name of the zone, “liara.ir”, max length: 253, pattern: ^([a-zA-Z0-9][\\-a-zA-Z0-9]*\\.)+[\\-a-zA-Z0-9]{2,20}$")
    status: Optional[StrictStr] = Field(default=None, description="The status of the zone, valid values: [CREATING, PENDING, ACTIVE, DELETING]")
    current_name_servers: Optional[List[StrictStr]] = Field(default=None, alias="currentNameServers")
    name_servers: Optional[List[StrictStr]] = Field(default=None, alias="nameServers")
    last_check_at: Optional[StrictStr] = Field(default=None, description="Last time when zones nameservers was checked", alias="lastCheckAt")
    created_at: Optional[StrictStr] = Field(default=None, description="Time when zone was created", alias="createdAt")
    __properties: ClassVar[List[str]] = ["id", "name", "status", "currentNameServers", "nameServers", "lastCheckAt", "createdAt"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Zone:
        """Create an instance of Zone from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.model_dump(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Zone:
        """Create an instance of Zone from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Zone.model_validate(obj)

        _obj = Zone.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "status": obj.get("status"),
            "currentNameServers": obj.get("currentNameServers"),
            "nameServers": obj.get("nameServers"),
            "lastCheckAt": obj.get("lastCheckAt"),
            "createdAt": obj.get("createdAt")
        })
        return _obj


