# coding: utf-8

"""
    Object Storage API Documentaion

    A scalable, reliable, and cost effective Object Storage solution to support your application from liara-cloud

    The version of the OpenAPI document: 1.0.0
    Contact: support@liara.ir
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr
from pydantic import Field
from openapi_client.models.stat_data_object_meta_data import StatDataObjectMetaData

class StatDataObject(BaseModel):
    """
    StatDataObject
    """
    size: Optional[Union[StrictFloat, StrictInt]] = None
    meta_data: Optional[StatDataObjectMetaData] = Field(default=None, alias="metaData")
    last_modified: Optional[StrictStr] = Field(default=None, alias="lastModified")
    version_id: Optional[StrictStr] = Field(default=None, alias="versionId")
    etag: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["size", "metaData", "lastModified", "versionId", "etag"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> StatDataObject:
        """Create an instance of StatDataObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.model_dump(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of meta_data
        if self.meta_data:
            _dict['metaData'] = self.meta_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> StatDataObject:
        """Create an instance of StatDataObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return StatDataObject.model_validate(obj)

        _obj = StatDataObject.model_validate({
            "size": obj.get("size"),
            "metaData": StatDataObjectMetaData.from_dict(obj.get("metaData")) if obj.get("metaData") is not None else None,
            "lastModified": obj.get("lastModified"),
            "versionId": obj.get("versionId"),
            "etag": obj.get("etag")
        })
        return _obj


