# coding: utf-8

"""
    PaaS

    Manage your apps using our API  [wss://api.iran.liara.ir?token=<api-token>&cmd=/bin/bash&project_id=<project-id>]( wss://api.iran.liara.ir?token=<api-token>&cmd=/bin/bash&project_id=<project-id>)  Parameters: - `token`: Your api token in liara - `cmd`: By default /bin/bash - `project_id`: The id of your project in liara  This `WebSocket` endpoint allows `real-time` communication with the projects service hosted at `Liara` You can use `WebSocket protocols` to send and receive data, enabling efficient and low-latency interactions with the projects

    The version of the OpenAPI document: 1.0.0
    Contact: info@liara.ir
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr
from pydantic import Field
from openapi_client.models.releases_releases_inner import ReleasesReleasesInner

class Releases(BaseModel):
    """
    Releases
    """
    total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total of releases")
    current_release: Optional[StrictStr] = Field(default=None, description="The currentRelease of releases", alias="currentRelease")
    ready_releases_count: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The total of releases", alias="readyReleasesCount")
    releases: Optional[List[ReleasesReleasesInner]] = Field(default=None, description="The total of releases")
    platform: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["total", "currentRelease", "readyReleasesCount", "releases", "platform"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Releases:
        """Create an instance of Releases from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.model_dump(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in releases (list)
        _items = []
        if self.releases:
            for _item in self.releases:
                if _item:
                    _items.append(_item.to_dict())
            _dict['releases'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Releases:
        """Create an instance of Releases from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Releases.model_validate(obj)

        _obj = Releases.model_validate({
            "total": obj.get("total"),
            "currentRelease": obj.get("currentRelease"),
            "readyReleasesCount": obj.get("readyReleasesCount"),
            "releases": [ReleasesReleasesInner.from_dict(_item) for _item in obj.get("releases")] if obj.get("releases") is not None else None,
            "platform": obj.get("platform")
        })
        return _obj


